%if %{_vendor} == "redhat"
%define rpmsort /usr/lib/rpm/redhat/rpmsort
%else
%define rpmsort /usr/lib/rpm/rpmsort
%endif
# kernel rpm version and release we are building against
%global _kverrel %(rpm -q --qf '%{VERSION}_%{RELEASE}\\n' `rpm -q kernel-devel | %{rpmsort} -r | head -n 1` | head -n 1)

Name:		ddn-sfablkdriver
Version:	3.1.5.0.48861
Release:	1%{?dist}
Summary:	%{name} kernel module

Group:		System Environment/Kernel
License:	GPL
Vendor:		DataDirect Networks, Inc.
URL:		http://www.ddn.com/
Requires:	kmod-ddn-sfablkdriver
Obsoletes:	sfablkdriver kmod-sfablkdriver
Source0:	%{name}-%{version}.tar.bz2
BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:	%kernel_module_package_buildreqs

%kernel_module_package -r %{_kverrel} %{?kmod_flavors}

%description
Modular Block-Device Driver for SFA-E Controllers


%prep
%setup -q
set -- *
mkdir source
mv "$@" source/
mkdir obj


%build
for flavor in %flavors_to_build ; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C %{kernel_source $flavor} M=$PWD/obj/$flavor \
		EXTRA_CFLAGS="-I${PWD}/source/include \
		-DCPLD_KERNEL_BUILD -DSFA_KERNEL_BUILD -DCP_VM_SUPPORT"
done


%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{name}
for flavor in %flavors_to_build ; do
	make -C %{kernel_source $flavor} modules_install \
		M=$PWD/obj/$flavor
	# Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc source/README



%changelog
* Wed Mar 28 2012 Greg Edwards <gedwards@ddn.com>
- Initial packaging.
