# RHEL kernel version the virtio_scsi source is based on
# change this when you refresh the source
%define rhel_base_kverrel 3.10.0-693.21.1.el7

# kernel rpm version and release we are building against
%define _kverrel %(rpm -q --qf '%{VERSION}_%{RELEASE}\\n' `rpm -q kernel-devel | /usr/lib/rpm/redhat/rpmsort -r | head -n 1` | head -n 1)

Name:           virtio-scsi
Version:        1.9.50535
Release:        1%{?dist}
Summary:        mq-aware virtio-scsi module for RHEL 7.x

Group:          System/Kernel
License:        GPLv2
Vendor:         DataDirect Networks, Inc.
URL:            http://www.ddn.com/
Requires:       kmod-virtio-scsi
Source0:        %{name}-%{rhel_base_kverrel}.tar.gz
Source1:        %{name}.files
Source2:        %{name}.conf
Patch0:         0001-virtio_scsi-support-multi-hw-queue-of-blk-mq.patch
Patch1:         0002-Advertise-scsimq-support-in-dmesg.patch
Patch2:         0003-virtio-scsi.h-Add-virtio_scsi_cmd_req_pi-VIRTIO_SCSI.patch
Patch3:         0004-virtio-scsi-Enable-DIF-DIX-modes-in-SCSI-host-LLD.patch
Patch4:         0005-virtio-scsi-fix-unused-variable-warning.patch
Patch5:         0006-virtio_scsi-don-t-select-CONFIG_BLK_DEV_INTEGRITY.patch
Patch6:         0007-scsi-virtio_scsi-fix-pi_bytes-out-in-on-4-KiB-block-.patch
Patch7:         0008-scsi-virtio-virtio_scsi-Set-can_queue-to-the-length-.patch
Patch8:         0009-virtio_scsi-add-workaround-for-max_sectors-overflow.patch
Patch9:         0010-scsi-virtio_scsi-always-read-VPD-pages-for-multiqueu.patch
Patch10:        0011-scsi-virtio_scsi-unplug-LUNs-when-events-missed.patch
Patch11:        0012-SHOULD-BE-LAST-include-header-from-current-directory.patch
BuildRoot:      %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

BuildRequires:  %kernel_module_package_buildreqs

%kernel_module_package -f %{SOURCE1} -r %{_kverrel} %{?kmod_flavors}

%description
virtio_scsi module from RHEL7 3.10 kernel with upstream patches for
SCSI multiqueue, T10 PI, and bug fixes.


%prep
%setup -q -n %{name}-%{rhel_base_kverrel}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
set -- *
mkdir source
mv "$@" source/
mkdir obj


%build
for flavor in %flavors_to_build ; do
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    cp obj/$flavor/drivers/scsi/virtio_scsi.c obj/$flavor
    cp obj/$flavor/include/uapi/linux/virtio_scsi.h obj/$flavor
    make -C %{kernel_source $flavor} M=$PWD/obj/$flavor
done


%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{name}
for flavor in %flavors_to_build ; do
    make -C %{kernel_source $flavor} modules_install \
        M=$PWD/obj/$flavor
    # Cleanup unnecessary kernel-generated module dependency files.
    find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done

install -m 644 -D %{SOURCE2} $RPM_BUILD_ROOT/etc/depmod.d/%{name}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Wed Sep 25 2019 Greg Edwards <gedwards@ddn.com> 1.9
- Backport commit 5ff843721467 ("scsi: virtio_scsi: unplug LUNs when events
  missed")
- Drop patch that increased size of event queue to 256.

* Tue May 14 2019 Greg Edwards <gedwards@ddn.com> 1.8
- Increase size of event queue to 256.

* Wed Feb 20 2019 Greg Edwards <gedwards@ddn.com> 1.7
- Include target kernel version in release string

* Wed Nov 07 2018 Matt Lupfer <mlupfer@ddn.com> 1.6
- Rework patch management
- Add upstream multiqueue read VPD pages patch (a680f1d463)

* Wed Oct 17 2018 Greg Edwards <gedwards@ddn.com> 1.5
- Work around struct Scsi_Host max_sectors overflow at 32 MiB

* Tue Oct 09 2018 Greg Edwards <gedwards@ddn.com> 1.4
- Fix the virtio-scsi.conf depmod.d file to do its intended purpose

* Wed Oct 03 2018 Greg Edwards <gedwards@ddn.com> 1.3
- Add upstream patch setting 'can_queue' value from virtqueue size

* Wed Apr 4 2018 Greg Edwards <gedwards@ddn.com> 1.2
- Add upstream T10 PI pass through patches
- Rename the virtio_scsi source tarball to include the kernel version and
  release it originated from

* Thu Mar 22 2018 Matt Lupfer <mlupfer@ddn.com> 1.1
- Add depmod override configuration
- Refreshed virtio_scsi.c source to kernel-3.10.0-693.21.1.el7
- Rename package to "virtio-scsi" from "ddn-virtio_scsi"

* Wed Jan 24 2018 Matt Lupfer <mlupfer@ddn.com> 1.0
- New version scheme, decoupled from CentOS kernel version
- Refreshed virtio_scsi.c source to linux-3.10.0-693.11.6.el7

* Tue Aug 8 2017 Matt Lupfer <mlupfer@ddn.com> 3.10.0_514.26.2-1.0
- Initial packaging
